window.Gleam.initSearch([{"doc":"germinal","title":"germinal","content":"# Germinal\n\nA gleam (not pure-gleam), terminal manipulation library based on [crossterm](https://github.com/crossterm-rs/crossterm) and [rustler](https://github.com/rusterlium/rustler). Currently, the functionality is not complete and unsafe to use. This library can only be run in erlang VM, but the support of Javascript would be considered in the future.\n\nTo see the source code, see [Github](https://github.com/onelone852/germinal).\n\n[![Package Version](https://img.shields.io/hexpm/v/germinal)](https://hex.pm/packages/germinal)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/germinal/)\n\n```sh\ngleam add germinal\n```\n\n```gleam\nimport germinal\n\npub fn main() {\n    use _ &lt;- result.try(germinal.enable_raw_mode())\n    use res &lt;- result.try(germinal.read())\n    io.debug(res)\n    use _ &lt;- result.try(germinal.disable_raw_mode())\n    Ok(Nil)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/germinal&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"germinal/types","title":"Event","content":"pub type Event {\n  FocusGained\n  FocusLost\n  Key(KeyEvent)\n  Paste(String)\n  Resize(Int, Int)\n}\n Represent any event in terminal. \n \n Currently, this library does not support mouse.\nFocusGained\n\n\nFocusLost\n\n\nKey(KeyEvent)\n\n\nPaste(String)\n\n\nResize(Int, Int)\n\n\nSynonyms:\ngerminal/types.Event\ngerminal/types Event","url":"germinal/types.html#Event"},{"doc":"germinal/types","title":"KeyCode","content":"pub type KeyCode {\n  Backspace\n  Enter\n  Left\n  Right\n  Up\n  Down\n  Home\n  End\n  PageUp\n  PageDown\n  Tab\n  BackTab\n  Delete\n  Insert\n  F(Int)\n  Char(String)\n  Null\n  Esc\n  CapsLock\n  ScrollLock\n  NumLock\n  PrintScreen\n  Pause\n  Menu\n  KeypadBegin\n}\n Key code.\nBackspace\n\n\nEnter\n\n\nLeft\n\n\nRight\n\n\nUp\n\n\nDown\n\n\nHome\n\n\nEnd\n\n\nPageUp\n\n\nPageDown\n\n\nTab\n\n\nBackTab\n\n\nDelete\n\n\nInsert\n\n\nF(Int)\n\n\nChar(String)\n\n\nNull\n\n\nEsc\n\n\nCapsLock\n\n\nScrollLock\n\n\nNumLock\n\n\nPrintScreen\n\n\nPause\n\n\nMenu\n\n\nKeypadBegin\n\n\nSynonyms:\ngerminal/types.KeyCode\ngerminal/types KeyCode","url":"germinal/types.html#KeyCode"},{"doc":"germinal/types","title":"KeyEvent","content":"pub type KeyEvent\n Key event.\n\nSynonyms:\ngerminal/types.KeyEvent\ngerminal/types KeyEvent","url":"germinal/types.html#KeyEvent"},{"doc":"germinal/types","title":"KeyEventKind","content":"pub type KeyEventKind {\n  Press\n  Repeat\n  Release\n}\n The kind of key event.\nPress\n\n\nRepeat\n\n\nRelease\n\n\nSynonyms:\ngerminal/types.KeyEventKind\ngerminal/types KeyEventKind","url":"germinal/types.html#KeyEventKind"},{"doc":"germinal/types","title":"KeyEventState","content":"pub type KeyEventState\n The state of key event.\n\nSynonyms:\ngerminal/types.KeyEventState\ngerminal/types KeyEventState","url":"germinal/types.html#KeyEventState"},{"doc":"germinal/types","title":"KeyModifiers","content":"pub type KeyModifiers\n\n\nSynonyms:\ngerminal/types.KeyModifiers\ngerminal/types KeyModifiers","url":"germinal/types.html#KeyModifiers"},{"doc":"germinal/types","title":"alt_modifier","content":"pub fn alt_modifier() -&gt; KeyModifiers\n Represent the ALT modifier.\nSynonyms:\ngerminal/types.alt_modifier\ngerminal/types alt_modifier","url":"germinal/types.html#alt_modifier"},{"doc":"germinal/types","title":"caps_lock_state","content":"pub fn caps_lock_state() -&gt; KeyEventState\n Represent the Caps Lock state.\nSynonyms:\ngerminal/types.caps_lock_state\ngerminal/types caps_lock_state","url":"germinal/types.html#caps_lock_state"},{"doc":"germinal/types","title":"contains_modifiers","content":"pub fn contains_modifiers(\n  parent_modifiers: KeyModifiers,\n  child_modifiers: KeyModifiers,\n) -&gt; Bool\n Return True if parent_modifiers contains child_modifiers. Return False if not.\nSynonyms:\ngerminal/types.contains_modifiers\ngerminal/types contains_modifiers","url":"germinal/types.html#contains_modifiers"},{"doc":"germinal/types","title":"contains_state","content":"pub fn contains_state(\n  parent_state: KeyEventState,\n  child_state: KeyEventState,\n) -&gt; Bool\n Return True if parent_state contains child_state. Return False if not.\nSynonyms:\ngerminal/types.contains_state\ngerminal/types contains_state","url":"germinal/types.html#contains_state"},{"doc":"germinal/types","title":"control_modifier","content":"pub fn control_modifier() -&gt; KeyModifiers\n\nSynonyms:\ngerminal/types.control_modifier\ngerminal/types control_modifier","url":"germinal/types.html#control_modifier"},{"doc":"germinal/types","title":"get_key_modifiers","content":"pub fn get_key_modifiers(event: KeyEvent) -&gt; KeyModifiers\n Return the key modifiers of the key event.\nSynonyms:\ngerminal/types.get_key_modifiers\ngerminal/types get_key_modifiers","url":"germinal/types.html#get_key_modifiers"},{"doc":"germinal/types","title":"get_keycode","content":"pub fn get_keycode(event: KeyEvent) -&gt; KeyCode\n Return the key code of the key event.\nSynonyms:\ngerminal/types.get_keycode\ngerminal/types get_keycode","url":"germinal/types.html#get_keycode"},{"doc":"germinal/types","title":"get_keyevent_kind","content":"pub fn get_keyevent_kind(event: KeyEvent) -&gt; KeyEventKind\n Return the kind of the key event.\nSynonyms:\ngerminal/types.get_keyevent_kind\ngerminal/types get_keyevent_kind","url":"germinal/types.html#get_keyevent_kind"},{"doc":"germinal/types","title":"get_keyevent_state","content":"pub fn get_keyevent_state(event: KeyEvent) -&gt; KeyEventState\n Return the state of the key event.\nSynonyms:\ngerminal/types.get_keyevent_state\ngerminal/types get_keyevent_state","url":"germinal/types.html#get_keyevent_state"},{"doc":"germinal/types","title":"keypad_state","content":"pub fn keypad_state() -&gt; KeyEventState\n Represent the KeyPad state.\nSynonyms:\ngerminal/types.keypad_state\ngerminal/types keypad_state","url":"germinal/types.html#keypad_state"},{"doc":"germinal/types","title":"none_modifier","content":"pub fn none_modifier() -&gt; KeyModifiers\n Represent no modifier.\nSynonyms:\ngerminal/types.none_modifier\ngerminal/types none_modifier","url":"germinal/types.html#none_modifier"},{"doc":"germinal/types","title":"none_state","content":"pub fn none_state() -&gt; KeyEventState\n Represent no state.\nSynonyms:\ngerminal/types.none_state\ngerminal/types none_state","url":"germinal/types.html#none_state"},{"doc":"germinal/types","title":"num_lock_state","content":"pub fn num_lock_state() -&gt; KeyEventState\n Represent the Num Lock state.\nSynonyms:\ngerminal/types.num_lock_state\ngerminal/types num_lock_state","url":"germinal/types.html#num_lock_state"},{"doc":"germinal/types","title":"or_modifiers","content":"pub fn or_modifiers(\n  modifiers1: KeyModifiers,\n  modifiers2: KeyModifiers,\n) -&gt; KeyModifiers\n Combine two modifiers.\nSynonyms:\ngerminal/types.or_modifiers\ngerminal/types or_modifiers","url":"germinal/types.html#or_modifiers"},{"doc":"germinal/types","title":"or_state","content":"pub fn or_state(\n  state1: KeyEventState,\n  state2: KeyEventState,\n) -&gt; KeyEventState\n Combine two state.\nSynonyms:\ngerminal/types.or_state\ngerminal/types or_state","url":"germinal/types.html#or_state"},{"doc":"germinal/types","title":"shift_modifier","content":"pub fn shift_modifier() -&gt; KeyModifiers\n Represent the SHIFT modifier.\nSynonyms:\ngerminal/types.shift_modifier\ngerminal/types shift_modifier","url":"germinal/types.html#shift_modifier"},{"doc":"germinal/types","title":"germinal/types","content":" A module containing types in germinal.","url":"germinal/types.html"},{"doc":"germinal","title":"disable_raw_mode","content":"pub fn disable_raw_mode() -&gt; Result(Nil, String)\n Disables the raw mode.\nSynonyms:\ngerminal.disable_raw_mode\ngerminal disable_raw_mode","url":"germinal.html#disable_raw_mode"},{"doc":"germinal","title":"enable_raw_mode","content":"pub fn enable_raw_mode() -&gt; Result(Nil, String)\n Enables the raw mode.\n \n Not disabling afterwards may cause weird behaviour of the terminal.\nSynonyms:\ngerminal.enable_raw_mode\ngerminal enable_raw_mode","url":"germinal.html#enable_raw_mode"},{"doc":"germinal","title":"poll","content":"pub fn poll(timeout_ms: Int) -&gt; Result(Bool, String)\n Checks if there is an Event available.\n Returns Ok(true) if an Event is available otherwise it returns Ok(false).\n Ok(true) guarantees that subsequent call to the read function won’t block.\n \n This function need raw mode to work properly.\n \n It can only be used in a single thread.\nSynonyms:\ngerminal.poll\ngerminal poll","url":"germinal.html#poll"},{"doc":"germinal","title":"read","content":"pub fn read() -&gt; Result(Event, String)\n Reads a single Event. This function blocks until an Event is recevived. The poll function can be used if blocking is not desired.\n \n This function need raw mode to work properly.\n \n It can only be used in single thread.\nSynonyms:\ngerminal.read\ngerminal read","url":"germinal.html#read"},{"doc":"germinal","title":"germinal","content":" A module containing functions that used to control terminal and read event. ","url":"germinal.html"}]);